OUTPUT_FORMAT("elf32-h8300", "elf32-h8300", "elf32-h8300")
OUTPUT_ARCH(h8300h)
ENTRY("_start")
MEMORY
{
	vectors(r)  : o = 0x0000, l = 0x0042
	rom(rx)		: o = 0x0042, l = 0x7FBE
	ram(wx)		: o = 0xF780, l = 0x0800
	stack(w)	: o = 0xFF80, l = 0x0000
}

SECTIONS 				
{ 					
.vectors : {
	SHORT(ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(DEFINED(_int_nmi)?ABSOLUTE(_int_nmi):ABSOLUTE(_start))
	SHORT(DEFINED(_int_trap0)?ABSOLUTE(_int_trap0):ABSOLUTE(_start))
	SHORT(DEFINED(_int_trap1)?ABSOLUTE(_int_trap1):ABSOLUTE(_start))
	SHORT(DEFINED(_int_trap2)?ABSOLUTE(_int_trap2):ABSOLUTE(_start))
	SHORT(DEFINED(_int_trap3)?ABSOLUTE(_int_trap3):ABSOLUTE(_start))
	SHORT(DEFINED(_int_break)?ABSOLUTE(_int_break):ABSOLUTE(_start))
	SHORT(DEFINED(_int_sleep)?ABSOLUTE(_int_sleep):ABSOLUTE(_start))
	SHORT(DEFINED(_int_irq0)?ABSOLUTE(_int_irq0):ABSOLUTE(_start))
	SHORT(DEFINED(_int_irq1)?ABSOLUTE(_int_irq1):ABSOLUTE(_start))
	SHORT(DEFINED(_int_irq2)?ABSOLUTE(_int_irq2):ABSOLUTE(_start))
	SHORT(DEFINED(_int_irq3)?ABSOLUTE(_int_irq3):ABSOLUTE(_start))
	SHORT(DEFINED(_int_wkp)?ABSOLUTE(_int_wkp):ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(DEFINED(_int_timerv)?ABSOLUTE(_int_timerv):ABSOLUTE(_start))
	SHORT(DEFINED(_int_sci3)?ABSOLUTE(_int_sci3):ABSOLUTE(_start))
	SHORT(DEFINED(_int_iic)?ABSOLUTE(_int_iic):ABSOLUTE(_start))
	SHORT(DEFINED(_int_adi)?ABSOLUTE(_int_adi):ABSOLUTE(_start))
	SHORT(DEFINED(_int_timerz1)?ABSOLUTE(_int_timerz1):ABSOLUTE(_start))
	SHORT(DEFINED(_int_timerz2)?ABSOLUTE(_int_timerz2):ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(DEFINED(_int_timerb)?ABSOLUTE(_int_timerb):ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(ABSOLUTE(_start))
	SHORT(DEFINED(_int_sci3_2)?ABSOLUTE(_int_sci3_2):ABSOLUTE(_start))
        }  > vectors
.text : {
	*(.text) 				
	*(.strings)
	*(.rodata*) 				
   	 _etext = . ; 
	} > rom
.tors : {
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	___dtors_end = . ;
	}  > rom
.data : AT ( ADDR(.tors) + SIZEOF(.tors) ){
	___data = . ;
	*(.data)
	*(.tiny)
	 _edata = .;
	} > ram
/* .bss : AT ( LOADADDR(.data) + SIZEOF(.data) ) { */
.bss : {
	 _bss_start = . ;
	*(.bss)
	*(COMMON)
	 _end = . ;  
	}  >ram
.stack : {
	 _stack = . ; 
	*(.stack)
	}  > stack
}
