 /*                                   */
 /*      Zak's H8 Monitor C code      */
 /*      init.c                       */
 /*                                   */
 /*   2001-2002 all rights reserved   */
 /*          by Kazutaka 'Zak' Sawa   */
 /*                                   */


#include "36064s.h"				/* I/OANZXpCN[ht@C */

#include "initialize.h"
#include "utilities.h"


/* EIb`hbO^C}[ */
static void initializeWDT(void)
{
	/*var*/
	UInt8					TCSRWD;

	/* Ƃ肠A~߂i΁j */
	TCSRWD = WDT.TCSRWD.BYTE;
	TCSRWD &= 0xC3;			
	WDT.TCSRWD.BYTE = TCSRWD;		// B4WI = 0 / TCSRWE݉
	TCSRWD |= 0x10;			
	WDT.TCSRWD.BYTE = TCSRWD;		// TCSRWE = 1 / WDON݉
	WDT.TCSRWD.BYTE = TCSRWD;		// WDON = 0 / WDT
}


/* f[^[ */
static void initializeDataMem(void)
{
	/* ANZXpϐ */
	BlockZero(&gDMem, sizeof(gDMem));
}


/* VAW[ */
static void initializeSCI(void)
{
	/*var*/
	volatile SInt16			dummy;

	/*functon*/
	SCI3.SCR3.BYTE = 0x00;			/* S~A{[[gNbN */
	SCI3.SMR.BYTE = 0x00;			/* [hA8bit 1stop non-pariA{[[gNbN*/
	SCI3.BRR = 23;						/* 19200bps */
  
	for(dummy = 500; dummy > 0; dummy--)					/* _~[1bit҂ */
		;
  	
	SCI3.SCR3.BYTE = 0x70;			/* M^MAM */
	dummy = SCI3.SSR.BYTE;		/* _~[̓ǂݏo */
	SCI3.SSR.BYTE = 0x80;			/* VAXe[^XNA */
	
	IO.PMR1.BIT.TXD = 1;			/* Tx|[gOut֐؂ւ */
}


/* VS-WRC003 ŒIO */
static void initializeVSWRC003(void)
{
	/* LEDo͏ */
	TZ.TOER.BIT.EA1 = 1;
	TZ.TOER.BIT.EB1 = 1;
	IO.PCR6 = 0x30;
	kBoardLED1 = 0;
	kBoardLED2 = 0;
	
	/* Button͏ */
	IO.PMR5.BIT.WKP5 = 0;
	IO.PCR5 = 0x00;
	IO.PUCR5.BIT.B5 = 1;			/* vAbv */
}


/* LCD */
#define __CutLCD__	 1
#ifndef __CutLCD__

static void initializeLCD(void)
{
	/* WX^ */
	IO.PCR1 = 0x07;
	IO.PCR5 = 0x0F;
	LCD_RS = 0;
	LCD_RW = 0;
	LCD_E = 0;
	LCD_Data &= 0xF0;
	
	/* LCD */
	delay(15000);

	writeLCDReg8(0x03);
	delay(4100);
	
	writeLCDReg8(0x03);
	delay(100);
	
	writeLCDReg8(0x03);
	delay(100);
	
	writeLCDReg8(0x02);
	delay(40);
	
	writeLCDReg4(0x28);
	delay(40);

	writeLCDReg4(0x0E);
	delay(40);

	writeLCDReg4(0x06);
	delay(40);

	writeLCDReg4(0x01);
	delay(1640);
}

#endif

/* `bv^ϐ̏ */
extern void	initialize(void)
{
	initializeWDT();
	initializeDataMem();
	initializeVSWRC003();
	initializeSCI();
//	initializeLCD();
}

