 /*                                   */
 /*      Zak's H8 Monitor C code      */
 /*      utilities.c                  */
 /*                                   */
 /*   2001-2009 all rights reserved   */
 /*          by Kazutaka 'Zak' Sawa   */
 /*                                   */


#include "36064s.h"				/* I/OANZXpCN[ht@C */

#include "utilities.h"



/* f[^Rs[ */
extern void	BlockMove
		 (const void*			SourcePtr,			/*  */
			const void*			DestPtr,			/*  */
			const SInt16		Length)				/*  */
	{
		/*var*/
		SInt16				counter;
		SInt8*				Source2Ptr;
		SInt8*				Dest2Ptr;

		/*function*/
		if (Length == 0)
			return;
		
		if (((UInt32)SourcePtr) > ((UInt32)DestPtr))
			{
				Source2Ptr = (SInt8*)SourcePtr;
				Dest2Ptr = (SInt8*)DestPtr;
				for (counter = Length; counter > 0; counter--)
					*(Dest2Ptr++) = *(Source2Ptr++);
			}
		else if (((UInt32)SourcePtr) < ((UInt32)DestPtr))
			{
				Source2Ptr = (SInt8*)SourcePtr + Length - 1;
				Dest2Ptr = (SInt8*)DestPtr + Length - 1;
				for (counter = Length; counter > 0; counter--)
					*(Dest2Ptr--) = *(Source2Ptr--);
			}
	}


/* 񒷌o */
extern UInt16	StringLength
		 (const SInt8*			SourcePtr)			/*  */
	{
		/*var*/
		UInt16				counter;

		/*function*/
		for (counter = 0; counter < kMaxStrLength; counter++)
			if (*(SourcePtr++) == 0x00)
				return(counter);
		
		return(kMaxStrLength);
	}


/* 啶 */
extern void	UpperString
		 (SInt8*				SourcePtr)			/*  */
	{
		/*var*/
		UInt16				counter;

		/*function*/
		for (counter = 0; counter < kMaxStrLength; counter++)
			{
				if ((*(SourcePtr) >= 'a') && (*(SourcePtr) <= 'z'))
					*(SourcePtr) -= ('a' - 'A');
				SourcePtr++;
			}
	}


/* r */
extern Boolean	CompString
		 (const SInt8*			aStr,				/*  */
			const SInt8*		bStr)				/*  */
	{
		/*function*/
		for (; (*aStr != 0x00) && (*bStr != 0x00); )
			{
				if (*aStr++ != *bStr++)
					return(false);
			}
		
		return((Boolean)((*aStr == 0x00) && (*bStr == 0x00)));
	}


/* Dec񐔒l */
extern Boolean	String2Num
		 (const SInt8*			theStr,				/*  */
			SInt32*				theNum)				/*  */
	{
		/*var*/
		UInt16				maxCounter;
		UInt16				counter;
		const SInt8*		aStr;
		Boolean				isMinus;
		SInt32				base;

		/*function*/
		/*  */
		*theNum = 0;

		/* mF */
		maxCounter = StringLength(theStr);
		
		/* LmF */
		aStr = theStr;
		for (counter = 0; counter > maxCounter; counter++)
			{
				if ((*aStr < '0') || (*aStr > '9'))
					if (! ((counter == 0) && (*aStr == '-')))		/* 擪̃}CiX̂݋e */
						return(false);
				aStr++;
			}
			
		/* }CiX`FbN */
		isMinus = (Boolean)(theStr[0] == '-');
			
		/*l*/
		base = 1;
		aStr = theStr + maxCounter - 1;
		for (counter = maxCounter; counter > 0; counter--)
			{
				*theNum += (*aStr - '0') * base;
				base *= 10;
				aStr--;
				
				if (isMinus && (counter == 2))
					break;
			}
			
		if (isMinus)
			*theNum = -(*theNum);
		
		return(true);
	}


/* Hex񐔒l */
extern Boolean	Hex2Num
		 (SInt8*				theStr,				/*  */
			UInt32*				theNum)				/*  */
	{
		/*var*/
		UInt16				maxCounter;
		UInt16				counter;
		SInt8*				aStr;
		SInt32				base;

		/*function*/
		/*  */
		*theNum = 0;

		/* mF */
		maxCounter = StringLength(theStr);
		
		/* 啶 */
		UpperString(theStr);
		
		/* LmF */
		aStr = theStr;
		for (counter = 0; counter < maxCounter; counter++, aStr++)
			{
				if ((*aStr >= '0') && (*aStr <= '9'))
					continue;
					
				if ((*aStr >= 'A') && (*aStr <= 'F'))
					continue;
					
				return(false);
			}
			
		/*l*/
		base = 1;
		aStr = theStr + maxCounter - 1;
		for (counter = maxCounter; counter > 0; counter--)
			{
				if ((*aStr >= '0') && (*aStr <= '9'))
					*theNum += (*aStr - '0') * base;
				else
					*theNum += (*aStr - 'A' + 10) * base;
					
				base *= 16;
				aStr--;
			}
			
		return(true);
	}


/* lHex */
extern Boolean	Num2Hex
		 (UInt32				theNum,				/*  */
			UInt32				theLength,			/*  */
			SInt8*				theStr)				/*  */
	{
		/*var*/
		UInt16				counter;
		UInt32				base;
		UInt16				oneChar;

		/*function*/
		if (theLength > kMaxHexNum)
			return(false);
		
		/*Hex*/
		base = 1L << ((theLength - 1) * 4L);
		for (counter = theLength; counter > 0; counter--)
			{
				oneChar = theNum / base;
				theNum %= base;
				base /= 16;
				
				if (oneChar < 10)
					oneChar += 0x30;
				else
					oneChar += 0x37;
					
				*(theStr++) = oneChar;
			}
		
		*(theStr) = 0x00;
		return(true);
	}


/*  */
extern void	BlockZero
		 (const void*			DestPtr,			/*  */
			const SInt16		Length)				/*  */
	{
		/*var*/
		SInt16				counter;
		SInt8*				Dest2Ptr;

		/*function*/
		Dest2Ptr = (SInt8*)DestPtr;
		
		for (counter = Length; counter > 0; counter--)
			*(Dest2Ptr++) = 0;
	}


/* f[^M */
extern void	sendData
		 (const SInt8*			theData,			/*  */
			SInt32				length)				/*  */
	{
		gDMem.SendPtr = (SInt8*)theData;
		gDMem.SendLength = length + 1;
		
	  SCI3.SCR3.BIT.TIE = 1;			/* M */
	}


/* 񑗐M */
extern void	sendString
		 (const SInt8*			String,				/*  */
			Boolean				withCRLF)			/*  */
	{
		/* ȑȎMbZ[WcĂꍇ͑M҂ */
		for (; gDMem.SendLength != 0; )
			;
		
		/* 񒷂Zbg */
		if (String == NULL)
			{
				gDMem.SendLength = 0;
			}
		else
			{
				gDMem.SendLength = StringLength(String);
				if (gDMem.SendLength > kMaxSendSize)
					gDMem.SendLength = kMaxSendSize;
					
				/* Mobt@Ƀf[^Rs[ */
				BlockMove(String, gDMem.SendBuffer, gDMem.SendLength);
			}
		gDMem.CurrentSendPos = 0;
		
		/* CRLF̕t */
		if (withCRLF)
			{
				gDMem.SendBuffer[gDMem.SendLength++] = 0x0A;
				gDMem.SendBuffer[gDMem.SendLength++] = 0x0D;
			}
		
		/* MJn */
		if (gDMem.SendLength > 0)
			sendData(gDMem.SendBuffer, gDMem.SendLength);
	}


/* M */
extern void	sendChar
		 (const SInt8			theChar)			/*  */
	{
		/* ȑȎMbZ[WcĂꍇ͑M҂ */
		for (; gDMem.SendLength != 0; )
			;
		
		/* 񒷂Zbg */
		gDMem.SendLength = 1;
		gDMem.CurrentSendPos = 0;
		
		/* Mobt@Ƀf[^Rs[ */
		gDMem.SendBuffer[0] = theChar;
		
		/* MJn */
		sendData(gDMem.SendBuffer, gDMem.SendLength);
	}


/* ԑ҂ */
static void	delay450ns(void)
	{
		/*var*/
		volatile SInt16			dummy;
	
		/*functon*/
		for(dummy = 8; dummy > 0; dummy--)
			;
	}

extern void	delay
		 (UInt16 						theTime)							/* us */
	{
		/*var*/
		volatile SInt16			dummy;
	
		/*functon*/
		for (; theTime > 0; theTime--)
			for(dummy = 16; dummy > 0; dummy--)					/* _~[1uSec҂ */
				;
	}

#define __CutLCD__	 1
#ifndef __CutLCD__


/* LCDWX^ */
extern void	writeLCDReg8
		 (const UInt8			theData)			/*  */
	{
		LCD_Data &= 0xF0;
		LCD_Data |= (theData & 0x0F);
		
		LCD_E = 1;
		delay450ns();
			
		LCD_E = 0;
		delay450ns();
	}


/* LCDWX^ */
extern void	writeLCDReg4
		 (const UInt8			theData)			/*  */
	{
		LCD_Data &= 0xF0;
		LCD_Data |= ((theData >> 4) & 0x0F);
		
		LCD_E = 1;
		delay450ns();
			
		LCD_E = 0;
		delay450ns();
		
		LCD_Data &= 0xF0;
		LCD_Data |= (theData & 0x0F);
		
		LCD_E = 1;
		delay450ns();
			
		LCD_E = 0;
		delay450ns();
	}


/* \ */
extern void	showLCDString
		 (const SInt8*			theStr,				/*  */
			const UInt8			theLine)			/*  */
	{
		/* var */
		UInt16					counter;
		
		/* function */
		LCD_RS = 0;
		
		if (theLine == 0)
			writeLCDReg4(0x02);
		else
			writeLCDReg4(0xC0);

		delay(40);

		LCD_RS = 1;
		for (counter = 16; counter > 0; counter--)
			{
				writeLCDReg4(*theStr++);
				delay(40);
			}
		LCD_RS = 0;
	}
	
#endif
