 /*                                   */
 /*      Zak's H8 Monitor C code      */
 /*      utilities.h                  */
 /*                                   */
 /*   2001-2002 all rights reserved   */
 /*          by Kazutaka 'Zak' Sawa   */
 /*                                   */


#ifndef __utilities__
#define __utilities__	 1

#include "zTypes.h"


#define	kMaxStrLength		255
#define	kMaxHexNum			8


/* @@@@@@ */
/* n */
/* @@@@@@ */

/* f[^Rs[ */
extern void	BlockMove
		 (const void*				SourcePtr,						/*  */
			const void*				DestPtr,							/*  */
			const SInt16			Length);							/*  */

/*  */
extern void	BlockZero
		 (const void*				DestPtr,							/*  */
			const SInt16			Length);							/*  */



/* @@@@@@ */
/* 񑀍n */
/* @@@@@@ */

/* 񒷌o */
extern UInt16	StringLength
		 (const SInt8*			SourcePtr);						/*  */

/* 啶 */
extern void	UpperString
		 (SInt8*						SourcePtr);						/*  */

/* r */
extern Boolean	CompString
		 (const SInt8*			aStr,									/*  */
			const SInt8*			bStr);								/*  */

/* Dec񐔒l */
extern Boolean	String2Num
		 (const SInt8*			theStr,								/*  */
			SInt32*						theNum);							/*  */

/* Hex񐔒l */
extern Boolean	Hex2Num
		 (SInt8*						theStr,								/*  */
			UInt32*						theNum);							/*  */

/* lHex */
extern Boolean	Num2Hex
		 (UInt32						theNum,								/*  */
			UInt32						theLength,						/*  */
			SInt8*						theStr);							/*  */



/* @@@@ */
/* Mn */
/* @@@@ */

/* f[^M */
extern void	sendData
		 (const SInt8*			theData,							/*  */
			SInt32						length);							/*  */

/* 񑗐M */
extern void	sendString
		 (const SInt8*			String,								/*  */
			Boolean						withCRLF);						/*  */

/* M */
extern void	sendChar
		 (const SInt8				theChar);							/*  */



/* @@@@ */
/* LCDn @*/
/* @@@@ */

/* LCDWX^ */
extern void	writeLCDReg8
		 (const UInt8				theData);							/*  */

extern void	writeLCDReg4
		 (const UInt8				theData);							/*  */

/* \ */
extern void	showLCDString
		 (const SInt8*			theStr,								/*  */
			const UInt8				theLine);							/*  */



/* @@@@ */
/* ̑@ */
/* @@@@ */

/* ԑ҂ */
extern void	delay
		 (UInt16 						theTime);							/* ms */

	
#endif

