 /*                                   */
 /*      Zak's H8 Monitor C code      */
 /*      zTypes.h                     */
 /*                                   */
 /*   2001-2009 all rights reserved   */
 /*          by Kazutaka 'Zak' Sawa   */
 /*                                   */


#ifndef __zTypes__
#define __zTypes__	 1

typedef	unsigned long				UInt32;
typedef	unsigned int				UInt16;
typedef	unsigned char				UInt8;

typedef	long						SInt32;
typedef	int							SInt16;
typedef	char						SInt8;

typedef enum
	{
		false = 0,
		true
	}
	Boolean;
	
#define NULL						((void*)0)
	
	

#define	kInitStack					0x0000FF80L
/* #define	kIntRAMAddress			0x0000FB80L  */
/* #define	kIntRAMAddress			0x0000FC00L  */


#define	kMaxSendSize				80
#define	kSendBufferSize				(kMaxSendSize + 2)
#define	kRecieveRingBufferSize		20
#define	kCommandBufferSize			20
#define	kMaxWordNum					4
#define	kWordSize					10


//#define	LCD_RS										IO.PDR1.BIT.B0
//#define	LCD_RW										IO.PDR1.BIT.B1
//#define	LCD_E										IO.PDR1.BIT.B2
//#define	LCD_Data									IO.PDR5.BYTE


// for VS-WRC003
#define kBoardLED1					IO.PDR6.BIT.B4
#define kBoardLED2					IO.PDR6.BIT.B5

#define kBoardButton				IO.PDR5.BIT.B5



typedef struct
	{
		/*------------------------------------------------*/
		/* f[^M֘A                                   */
		/*------------------------------------------------*/
		
		/* Mobt@֘A */
		volatile SInt32		SendLength;
		SInt32				CurrentSendPos;
		SInt8*				SendPtr;
		SInt8				SendBuffer[kSendBufferSize];				/* C String 80+CRLF */
		
		/* Mobt@֘A */
		volatile SInt16		CurrentRecievePos;
		volatile SInt16		CurrentCopyedPos;
		SInt8				RecieveBuffer[kRecieveRingBufferSize];		/* C String 20 */
		
		/* svR}h */
		SInt16				CommandLength;
		SInt8				CurrentCommandLine[kCommandBufferSize];		/* C String 20 */
		SInt8				LastCommandLine[kCommandBufferSize];		/* C String 20 */
		SInt16				NumWords;									/* ꐔ */
		SInt8				CurrentWords[kMaxWordNum][kWordSize];		/* 10 4 */
	}
	DataMemRec, *DataMemPtr;
	
/* #define gDMem    (*(volatile DataMemPtr)kIntRAMAddress)  */
extern  DataMemRec			gDMem;


#endif

